设为首页收藏本站

晓东CAD家园-论坛

 找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 118|回复: 3

[分享] 数据修改事件 特定半径圆自动加中心线

[复制链接]

已领礼包: 7个

财富等级: 恭喜发财

发表于 2018-12-8 10:05:29 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有帐号?立即注册

x
  1. 之前用lisp写过没达到想要的效果,看到VBA字典的资料所以转VBA了
复制代码
ezgif.com-video-to-gif.gif
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!

已领礼包: 7个

财富等级: 恭喜发财

 楼主| 发表于 2018-12-8 10:07:13 | 显示全部楼层
  1. Dim Czxx As New Dictionary
  2. Private Sub AcadDocument_ObjectModified(ByVal Object As Object)
  3.     Dim Str As String
  4.     Dim ptC As Variant
  5.     Dim ptC1(2) As Double
  6.     Dim ptC2(2) As Double
  7.     Dim Obj As Object
  8.     Dim Jubc As String
  9.     Dim Jubl1 As String
  10.     Dim Jubl2 As String
  11.     Str = Object.ObjectName
  12.     If StrComp(Str, "AcDbCircle", vbTextCompare) = 0 Then
  13.         Jubc = Object.Handle
  14.         If Czxx.Exists(Jubc) Then
  15.             Dim Val As Variant
  16.             Str = Czxx.Item(Jubc)
  17.             Val = Split(Str, "|")
  18.             Set Obj = ThisDrawing.HandleToObject(Val(0))
  19.             Obj.Delete
  20.             Set Obj = ThisDrawing.HandleToObject(Val(1))
  21.             Obj.Delete
  22.             Czxx.Remove (Jubc)
  23.             If Object.radius = 5 Then
  24.                 ptC = Object.Center '»ñè¡Ô2DÄ×ø±ê
  25.                 ptC1(0) = ptC(0) - 8: ptC1(1) = ptC(1): ptC1(2) = ptC(2)
  26.                 ptC2(0) = ptC(0) + 8: ptC2(1) = ptC(1): ptC2(2) = ptC(2)
  27.                 Set Obj = ThisDrawing.ModelSpace.Addline(ptC1, ptC2) 'ÖDDÄÏß1 oá
  28.                 Jubl1 = Obj.Handle
  29.                 ptC1(0) = ptC(0): ptC1(1) = ptC(1) + 8: ptC1(2) = ptC(2)
  30.                 ptC2(0) = ptC(0): ptC2(1) = ptC(1) - 8: ptC2(2) = ptC(2)
  31.                 Set Obj = ThisDrawing.ModelSpace.Addline(ptC1, ptC2) 'ÖDDÄÏß2 êú
  32.                 Jubl2 = Obj.Handle
  33.                 Set Czxx = CreateObject("Scripting.Dictionary")
  34.                 Czxx(Jubc) = Jubl1 & "|" & Jubl2
  35.             End If
  36.         Else
  37.             If Object.radius = 5 Then
  38.                 Jubc = Object.Handle
  39.                 ptC = Object.Center
  40.                 ptC1(0) = ptC(0) - 8: ptC1(1) = ptC(1): ptC1(2) = ptC(2)
  41.                 ptC2(0) = ptC(0) + 8: ptC2(1) = ptC(1): ptC2(2) = ptC(2)
  42.                 Set Obj = ThisDrawing.ModelSpace.Addline(ptC1, ptC2)
  43.                 Jubl1 = Obj.Handle
  44.                 ptC1(0) = ptC(0): ptC1(1) = ptC(1) + 8: ptC1(2) = ptC(2)
  45.                 ptC2(0) = ptC(0): ptC2(1) = ptC(1) - 8: ptC2(2) = ptC(2)
  46.                 Set Obj = ThisDrawing.ModelSpace.Addline(ptC1, ptC2)
  47.                 Jubl2 = Obj.Handle
  48.                 Set Czxx = CreateObject("Scripting.Dictionary")
  49.                 Czxx(Jubc) = Jubl1 & "|" & Jubl2
  50.             End If
  51.         End If
  52.     End If
  53. End Sub

评分

参与人数 2D豆 +25 收起 理由
mikewolf2k + 5 很给力!经验;技术要点;资料分享奖!
XDSoft + 20 很给力!经验;技术要点;资料分享奖!

查看全部评分

论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 327个

财富等级: 日进斗金

发表于 2018-12-13 08:09:22 | 显示全部楼层
这段代码该怎么用呀

点评

工具-引用-浏览-找到scrrun.dll-确认 然后代码放在 Thisdrawing 里面就可以了 画直径10的圆就可以看见变化了 [attachimg]82496[/attachimg]  详情 回复 发表于 2018-12-13 11:46
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

已领礼包: 7个

财富等级: 恭喜发财

 楼主| 发表于 2018-12-13 11:46:09 | 显示全部楼层
zyclyl 发表于 2018-12-13 08:09
这段代码该怎么用呀

工具-引用-浏览-找到scrrun.dll-确认
然后代码放在 Thisdrawing 里面就可以了
画直径10的圆就可以看见变化了

微信截图_20181213114001.jpg
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
回复 支持 反对

使用道具 举报

您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|小黑屋|手机版|Archiver|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )  

GMT+8, 2019-5-21 12:54 , Processed in 0.150120 second(s), 31 queries , Gzip On, WinCache On.

Powered by Discuz! X3.4

© 2001-2017 Comsenz Inc.

快速回复 返回顶部 返回列表